com.tibbo.aggregate.common.expression

## Class Reference

- java.lang.Object
- - com.tibbo.aggregate.common.expression.Reference

- All Implemented Interfaces:
    PublicCloneable, java.lang.Cloneable

      public class Reference
      extends java.lang.Object
      implements java.lang.Cloneable, PublicCloneable

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static char` | `ACTION_SIGN`
    `static java.lang.Integer` | `APPEARANCE_BUTTON`
    `static java.lang.Integer` | `APPEARANCE_LINK`
    `static char` | `CONTEXT_END`
    `static char` | `EVENT_SIGN`
    `static char` | `FIELD_BEGIN`
    `static char` | `FIELD_SEPARATOR`
    `static char` | `PARAMS_BEGIN`
    `static char` | `PARAMS_END`
    `static char` | `PROPERTY_BEGIN`
    `static char` | `ROW_BEGIN`
    `static char` | `ROW_END`
    `static java.lang.String` | `SCHEMA_ACTION`
    `static char` | `SCHEMA_END`
    `static java.lang.String` | `SCHEMA_ENVIRONMENT`
    `static java.lang.String` | `SCHEMA_FORM`
    `static java.lang.String` | `SCHEMA_GRANULATION`
    `static java.lang.String` | `SCHEMA_MENU`
    `static java.lang.String` | `SCHEMA_PARENT`
    `static java.lang.String` | `SCHEMA_STATISTICS`
    `static java.lang.String` | `SCHEMA_TABLE`
    `static java.lang.String` | `SCHEMA_WEB`
    `static char` | `SERVER_END`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Reference()`
    `Reference(java.lang.String source)`
    `Reference(java.lang.String entity, int entityType)`
    `Reference(java.lang.String entity, int entityType, java.lang.String field)`
    `Reference(java.lang.String entity, int entityType, java.lang.String field, int line)`
    `Reference(java.lang.String server, java.lang.String context)`
    `Reference(java.lang.String context, java.lang.String entity, int entityType)`
    `Reference(java.lang.String context, java.lang.String entity, int entityType, java.lang.String field)`
    `Reference(java.lang.String context, java.lang.String function, java.lang.Object[] parameters)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addField(java.lang.String field)`
    `void` | `addField(java.lang.String field, java.lang.Integer record)`
    `void` | `addParameter(Expression parameter)`
    `void` | `addParameter(java.lang.String parameter)`
    `Reference` | `clone()`
    `boolean` | `equals(java.lang.Object obj)`
    `java.lang.Integer` | `getAppearance()`
    `java.lang.String` | `getContext()`
    `java.lang.String` | `getEntity()`
    `int` | `getEntityType()`
    `java.lang.String` | `getField()`
    `java.util.List<Pair<java.lang.String,java.lang.Integer>>` | `getFields()`
    `java.lang.String` | `getImage()`
    `java.util.List<java.lang.Object>` | `getParameters()`
    `java.lang.String` | `getProperty()`
    `java.lang.Integer` | `getRow()`
    `java.lang.String` | `getSchema()`
    `java.lang.String` | `getServer()`
    `int` | `hashCode()`
    `protected void` | `parse(java.lang.String source)`
    `void` | `setAppearance(java.lang.Integer appearance)`
    `void` | `setContext(java.lang.String context)`
    `void` | `setEntity(java.lang.String entity)`
    `void` | `setEntityType(int entityType)`
    `void` | `setField(java.lang.String field)`
    `void` | `setFields(java.util.List<Pair<java.lang.String,java.lang.Integer>> fields)`
    `void` | `setProperty(java.lang.String property)`
    `void` | `setRow(java.lang.Integer row)`
    `void` | `setSchema(java.lang.String schema)`
    `void` | `setServer(java.lang.String server)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### SCHEMA_FORM

          public static final java.lang.String SCHEMA_FORM

      See Also:
        Constant Field Values

    - #### SCHEMA_WEB

          public static final java.lang.String SCHEMA_WEB

      See Also:
        Constant Field Values

    - #### SCHEMA_TABLE

          public static final java.lang.String SCHEMA_TABLE

      See Also:
        Constant Field Values

    - #### SCHEMA_STATISTICS

          public static final java.lang.String SCHEMA_STATISTICS

      See Also:
        Constant Field Values

    - #### SCHEMA_GRANULATION

          public static final java.lang.String SCHEMA_GRANULATION

      See Also:
        Constant Field Values

    - #### SCHEMA_ENVIRONMENT

          public static final java.lang.String SCHEMA_ENVIRONMENT

      See Also:
        Constant Field Values

    - #### SCHEMA_PARENT

          public static final java.lang.String SCHEMA_PARENT

      See Also:
        Constant Field Values

    - #### SCHEMA_MENU

          public static final java.lang.String SCHEMA_MENU

      See Also:
        Constant Field Values

    - #### SCHEMA_ACTION

          public static final java.lang.String SCHEMA_ACTION

      See Also:
        Constant Field Values

    - #### EVENT_SIGN

          public static final char EVENT_SIGN

      See Also:
        Constant Field Values

    - #### ACTION_SIGN

          public static final char ACTION_SIGN

      See Also:
        Constant Field Values

    - #### PARAMS_BEGIN

          public static final char PARAMS_BEGIN

      See Also:
        Constant Field Values

    - #### PARAMS_END

          public static final char PARAMS_END

      See Also:
        Constant Field Values

    - #### SCHEMA_END

          public static final char SCHEMA_END

      See Also:
        Constant Field Values

    - #### SERVER_END

          public static final char SERVER_END

      See Also:
        Constant Field Values

    - #### CONTEXT_END

          public static final char CONTEXT_END

      See Also:
        Constant Field Values

    - #### FIELD_BEGIN

          public static final char FIELD_BEGIN

      See Also:
        Constant Field Values

    - #### FIELD_SEPARATOR

          public static final char FIELD_SEPARATOR

      See Also:
        Constant Field Values

    - #### ROW_BEGIN

          public static final char ROW_BEGIN

      See Also:
        Constant Field Values

    - #### ROW_END

          public static final char ROW_END

      See Also:
        Constant Field Values

    - #### PROPERTY_BEGIN

          public static final char PROPERTY_BEGIN

      See Also:
        Constant Field Values

    - #### APPEARANCE_LINK

          public static final java.lang.Integer APPEARANCE_LINK

    - #### APPEARANCE_BUTTON

          public static final java.lang.Integer APPEARANCE_BUTTON

  - ### Constructor Detail

    - #### Reference

          public Reference()

    - #### Reference

          public Reference(java.lang.String source)

    - #### Reference

          public Reference(java.lang.String server,
                           java.lang.String context)

    - #### Reference

          public Reference(java.lang.String entity,
                           int entityType)

    - #### Reference

          public Reference(java.lang.String entity,
                           int entityType,
                           java.lang.String field)

    - #### Reference

          public Reference(java.lang.String entity,
                           int entityType,
                           java.lang.String field,
                           int line)

    - #### Reference

          public Reference(java.lang.String context,
                           java.lang.String entity,
                           int entityType,
                           java.lang.String field)

    - #### Reference

          public Reference(java.lang.String context,
                           java.lang.String entity,
                           int entityType)

    - #### Reference

          public Reference(java.lang.String context,
                           java.lang.String function,
                           java.lang.Object[] parameters)

  - ### Method Detail

    - #### parse

          protected void parse(java.lang.String source)

    - #### getServer

          public java.lang.String getServer()

    - #### getContext

          public java.lang.String getContext()

    - #### getEntity

          public java.lang.String getEntity()

    - #### getEntityType

          public int getEntityType()

    - #### getField

          public java.lang.String getField()

    - #### getFields

          public java.util.List<Pair<java.lang.String,java.lang.Integer>> getFields()

    - #### getParameters

          public java.util.List<java.lang.Object> getParameters()

    - #### getRow

          public java.lang.Integer getRow()

    - #### getSchema

          public java.lang.String getSchema()

    - #### getProperty

          public java.lang.String getProperty()

    - #### getImage

          public java.lang.String getImage()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### setContext

          public void setContext(java.lang.String context)

    - #### setEntity

          public void setEntity(java.lang.String entity)

    - #### setEntityType

          public void setEntityType(int entityType)

    - #### addParameter

          public void addParameter(java.lang.String parameter)

    - #### addParameter

          public void addParameter(Expression parameter)

    - #### setField

          public void setField(java.lang.String field)

    - #### setFields

          public void setFields(java.util.List<Pair<java.lang.String,java.lang.Integer>> fields)

    - #### addField

          public void addField(java.lang.String field)

    - #### addField

          public void addField(java.lang.String field,
                               java.lang.Integer record)

    - #### setProperty

          public void setProperty(java.lang.String property)

    - #### setSchema

          public void setSchema(java.lang.String schema)

    - #### setRow

          public void setRow(java.lang.Integer row)

    - #### setServer

          public void setServer(java.lang.String server)

    - #### clone

          public Reference clone()

      Specified by:
        `clone` in interface `PublicCloneable`
      Overrides:
        `clone` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### getAppearance

          public java.lang.Integer getAppearance()

    - #### setAppearance

          public void setAppearance(java.lang.Integer appearance)